unit librariestestmw;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ctutils,
  ExtCtrls, ComCtrls,

  ffmpeg_loader,

  libavdevice,
  libavfilter,
  libpostproc,
  libswscale,
  libswresample,
  libavformat,
  libavcodec,
  libavutil;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    Memo5: TMemo;
    Memo6: TMemo;
    Memo7: TMemo;
    Memo8: TMemo;
    PageControl1: TPageControl;
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FLoaderFFmpeg:TLoaderFFmpeg;
    FWorkingMemo:TMemo;
    procedure doWriteToMemo(const isok:boolean;const astr:string);
    procedure doCheckVar(aaa:Pointer; Const aname:string);

    procedure TestLibFunctions;

    procedure TestLibavdevice;
    procedure TestLibavfilter;
    procedure TestLibavformat;
    procedure TestLibpostproc;  
    procedure TestLibswscale;
    procedure TestLibswresample;  
    procedure TestLibavcodec;   
    procedure TestLibavutil;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.frm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
 FLoaderFFmpeg:=TLoaderFFmpeg.Create(Nil);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FLoaderFFmpeg.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
 var xOK:boolean;
     ss:String;
begin
 Memo1.Clear;
 Memo2.Clear; 
 Memo3.Clear;   
 Memo4.Clear;
 Memo5.Clear; 
 Memo6.Clear; 
 Memo7.Clear; 
 Memo8.Clear;

 FLoaderFFmpeg.Active:=True;

  if FLoaderFFmpeg.IslibavDevice_Loaded=False then
   Memo1.Lines.add('ERROR: '+FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+avdeviceLibName+' NOT Loaded') else
   Memo1.Lines.add(FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+avdeviceLibName+' Loaded OK');

  if FLoaderFFmpeg.Islibavfilter_Loaded=False then
   Memo2.Lines.add('ERROR: '+FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+avfilterLibName+' NOT Loaded') else
   Memo2.Lines.add(FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+avfilterLibName+' Loaded OK');

  if FLoaderFFmpeg.Islibavformat_Loaded=False then
   Memo3.Lines.add('ERROR: '+FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+avformatLibName+' NOT Loaded') else
   Memo3.Lines.add(FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+avformatLibName+' Loaded OK');

  if FLoaderFFmpeg.Islibpostproc_Loaded=False then
   Memo4.Lines.add('ERROR: '+FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+postprocLibName+' NOT Loaded') else
   Memo4.Lines.add(FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+postprocLibName+' Loaded OK');

  if FLoaderFFmpeg.Islibswscale_Loaded=False then
   Memo5.Lines.add('ERROR: '+FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+swscaleLibName+' NOT Loaded') else
   Memo5.Lines.add(FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+swscaleLibName+' Loaded OK');

  if FLoaderFFmpeg.Islibswresample_Loaded=False then
   Memo6.Lines.add('ERROR: '+FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+swresampleLibName+' NOT Loaded') else
   Memo6.Lines.add(FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+swresampleLibName+' Loaded OK');

  if FLoaderFFmpeg.Islibavcodec_Loaded=False then
   Memo7.Lines.add('ERROR: '+FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+avcodecLibName+' NOT Loaded') else
   Memo7.Lines.add(FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+avcodecLibName+' Loaded OK');

  if FLoaderFFmpeg.Islibavutil_Loaded=False then
   Memo8.Lines.add('ERROR: '+FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+avutilLibName+' NOT Loaded') else
   Memo8.Lines.add(FLoaderFFmpeg.LibrariesDir+ctGetDirTrail+avutilLibName+' Loaded OK');

  TestLibFunctions;

  FLoaderFFmpeg.Active:=False;

end;


procedure TForm1.TestLibFunctions;
begin
 TestLibavdevice;
 TestLibavfilter;
 TestLibavformat;
 TestLibpostproc;
 TestLibswscale;
 TestLibswresample;
 TestLibavcodec;
 TestLibavutil;
end;

//==================================================================
//==================================================================

procedure TForm1.doWriteToMemo(const isok:boolean;const astr:string);
begin
  case RadioGroup1.ItemIndex of
   0:begin
      FWorkingMemo.Lines.add(astr);
      exit;
   end;
  1: begin
     if isok=false then
       FWorkingMemo.Lines.add(astr);
     exit;
   end;

   2:begin
     if isok=True then
       FWorkingMemo.Lines.add(astr);
     exit;
     end;

  end;
end;

procedure TForm1.doCheckVar(aaa:Pointer; Const aname:string);
 begin
  if aaa=nil then
    doWriteToMemo(false,aname+'          is NIL ????????') else
    doWriteToMemo(true ,aname+'          Is OK');
 end;

//==================================================================  
//==================================================================
//==================================================================

                
procedure TForm1.TestLibavdevice;
begin
   FWorkingMemo:=Memo1;
   FWorkingMemo.Lines.add('........................................');
   FWorkingMemo.Lines.add('');
   FWorkingMemo.Lines.BeginUpdate;

   doCheckVar(avdevice_version,'avdevice_version');
   doCheckVar(avdevice_configuration,'avdevice_configuration');
   doCheckVar(avdevice_license,'avdevice_license');
   doCheckVar(avdevice_register_all,'avdevice_register_all');   
   doCheckVar(av_device_ffversion,'av_device_ffversion');
   doCheckVar(av_input_audio_device_next,'av_input_audio_device_next');
   doCheckVar(av_input_video_device_next,'av_input_video_device_next');
   doCheckVar(av_output_audio_device_next,'av_output_audio_device_next');
   doCheckVar(av_output_video_device_next,'av_output_video_device_next');
   doCheckVar(avdevice_app_to_dev_control_message,'avdevice_app_to_dev_control_message');
   doCheckVar(avdevice_dev_to_app_control_message,'avdevice_dev_to_app_control_message');
   doCheckVar(avdevice_list_devices,'avdevice_list_devices');
   doCheckVar(avdevice_free_list_devices,'avdevice_free_list_devices');
   doCheckVar(avdevice_list_input_sources,'avdevice_list_input_sources');
   doCheckVar(avdevice_list_output_sinks,'avdevice_list_output_sinks');

   FWorkingMemo.Lines.EndUpdate;

end;

procedure TForm1.TestLibavfilter;
begin
   FWorkingMemo:=Memo2;
   FWorkingMemo.Lines.add('........................................');
   FWorkingMemo.Lines.add('');
   FWorkingMemo.Lines.BeginUpdate;

   doCheckVar(avfilter_version,'avfilter_version');
   doCheckVar(avfilter_configuration,'avfilter_configuration');
   doCheckVar(avfilter_license,'avfilter_license');
   doCheckVar(avfilter_pad_get_name,'avfilter_pad_get_name');
   doCheckVar(avfilter_filter_pad_count,'avfilter_filter_pad_count');
   doCheckVar(avfilter_link,'avfilter_link');
   doCheckVar(avfilter_link_free,'avfilter_link_free');
   doCheckVar(avfilter_config_links,'avfilter_config_links');
   doCheckVar(avfilter_process_command,'avfilter_process_command');
   doCheckVar(av_filter_iterate,'av_filter_iterate');
   doCheckVar(avfilter_get_by_name,'avfilter_get_by_name');
   doCheckVar(avfilter_init_str,'avfilter_init_str');
   doCheckVar(avfilter_init_dict,'avfilter_init_dict');
   doCheckVar(avfilter_free,'avfilter_free');
   doCheckVar(avfilter_insert_filter,'avfilter_insert_filter');
   doCheckVar(avfilter_graph_alloc_filter,'avfilter_graph_alloc_filter');
   doCheckVar(avfilter_graph_get_filter,'avfilter_graph_get_filter');
   doCheckVar(avfilter_graph_create_filter,'avfilter_graph_create_filter');
   doCheckVar(avfilter_graph_set_auto_convert,'avfilter_graph_set_auto_convert');
   doCheckVar(avfilter_graph_config,'avfilter_graph_config');
   doCheckVar(avfilter_graph_free,'avfilter_graph_free');
   doCheckVar(avfilter_inout_free,'avfilter_inout_free');
   doCheckVar(avfilter_graph_parse,'avfilter_graph_parse');
   doCheckVar(avfilter_graph_parse_ptr,'avfilter_graph_parse_ptr');
   doCheckVar(avfilter_graph_parse2,'avfilter_graph_parse2');
   doCheckVar(avfilter_graph_send_command,'avfilter_graph_send_command');
   doCheckVar(avfilter_graph_queue_command,'avfilter_graph_queue_command');
   doCheckVar(avfilter_graph_dump,'avfilter_graph_dump');
   doCheckVar(avfilter_graph_request_oldest,'avfilter_graph_request_oldest');  
   doCheckVar(avfilter_inout_alloc,'avfilter_inout_alloc');          
   doCheckVar(avfilter_get_class,'avfilter_get_class');  
   doCheckVar(avfilter_graph_alloc,'avfilter_graph_alloc'); 
   doCheckVar(av_buffersrc_get_nb_failed_requests,'av_buffersrc_get_nb_failed_requests');
   doCheckVar(av_buffersrc_parameters_alloc,'av_buffersrc_parameters_alloc');
   doCheckVar(av_buffersrc_parameters_set,'av_buffersrc_parameters_set');
   doCheckVar(av_buffersrc_write_frame,'av_buffersrc_write_frame');
   doCheckVar(av_buffersrc_add_frame,'av_buffersrc_add_frame');
   doCheckVar(av_buffersrc_add_frame_flags,'av_buffersrc_add_frame_flags');
   doCheckVar(av_buffersrc_close,'av_buffersrc_close'); 
   doCheckVar(av_buffersink_get_frame_flags,'av_buffersink_get_frame_flags');
   doCheckVar(av_buffersink_set_frame_size,'av_buffersink_set_frame_size');
   doCheckVar(av_buffersink_get_type,'av_buffersink_get_type');
   doCheckVar(av_buffersink_get_format,'av_buffersink_get_format');
   doCheckVar(av_buffersink_get_w,'av_buffersink_get_w');
   doCheckVar(av_buffersink_get_h,'av_buffersink_get_h');
   doCheckVar(av_buffersink_get_channels,'av_buffersink_get_channels');
   doCheckVar(av_buffersink_get_channel_layout,'av_buffersink_get_channel_layout');
   doCheckVar(av_buffersink_get_sample_rate,'av_buffersink_get_sample_rate');
   doCheckVar(av_buffersink_get_hw_frames_ctx,'av_buffersink_get_hw_frames_ctx');
   doCheckVar(av_buffersink_get_frame,'av_buffersink_get_frame');
   doCheckVar(av_buffersink_get_samples,'av_buffersink_get_samples');
   doCheckVar(av_buffersink_get_time_base,'av_buffersink_get_time_base');
   doCheckVar(av_buffersink_get_frame_rate,'av_buffersink_get_frame_rate');
   doCheckVar(av_buffersink_get_sample_aspect_ratio,'av_buffersink_get_sample_aspect_ratio');

   FWorkingMemo.Lines.EndUpdate;

end;

procedure TForm1.TestLibavformat;
begin
   FWorkingMemo:=Memo3;
   FWorkingMemo.Lines.add('........................................');
   FWorkingMemo.Lines.add('');
   FWorkingMemo.Lines.BeginUpdate;

   doCheckVar(avformat_version,'avformat_version');
   doCheckVar(avformat_configuration,'avformat_configuration');
   doCheckVar(avformat_license,'avformat_license');
   doCheckVar(avformat_network_init,'avformat_network_init');
   doCheckVar(avformat_network_deinit,'avformat_network_deinit');
   doCheckVar(av_disposition_from_string,'av_disposition_from_string');
   doCheckVar(av_disposition_to_string,'av_disposition_to_string');
   doCheckVar(av_get_packet,'av_get_packet');
   doCheckVar(av_append_packet,'av_append_packet');
   doCheckVar(av_stream_get_parser,'av_stream_get_parser');
   doCheckVar(av_stream_get_end_pts,'av_stream_get_end_pts');
   doCheckVar(av_format_inject_global_side_data,'av_format_inject_global_side_data');
   doCheckVar(av_fmt_ctx_get_duration_estimation_method,'av_fmt_ctx_get_duration_estimation_method');
   doCheckVar(av_muxer_iterate,'av_muxer_iterate');
   doCheckVar(av_demuxer_iterate,'av_demuxer_iterate');
   doCheckVar(avformat_alloc_context,'avformat_alloc_context');
   doCheckVar(avformat_free_context,'avformat_free_context');
   doCheckVar(avformat_new_stream,'avformat_new_stream');
   doCheckVar(av_stream_add_side_data,'av_stream_add_side_data');
   doCheckVar(av_stream_new_side_data,'av_stream_new_side_data');
   doCheckVar(av_stream_get_side_data,'av_stream_get_side_data');
   doCheckVar(av_new_program,'av_new_program');
   doCheckVar(avformat_alloc_output_context2,'avformat_alloc_output_context2');
   doCheckVar(av_find_input_format,'av_find_input_format');
   doCheckVar(av_probe_input_format,'av_probe_input_format');
   doCheckVar(av_probe_input_format2,'av_probe_input_format2');
   doCheckVar(av_probe_input_format3,'av_probe_input_format3');
   doCheckVar(av_probe_input_buffer2,'av_probe_input_buffer2');
   doCheckVar(av_probe_input_buffer,'av_probe_input_buffer');
   doCheckVar(avformat_open_input,'avformat_open_input');
   doCheckVar(avformat_find_stream_info,'avformat_find_stream_info');
   doCheckVar(av_find_program_from_stream,'av_find_program_from_stream');
   doCheckVar(av_program_add_stream_index,'av_program_add_stream_index');
   doCheckVar(av_find_best_stream,'av_find_best_stream');
   doCheckVar(av_read_frame,'av_read_frame');
   doCheckVar(av_seek_frame,'av_seek_frame');
   doCheckVar(avformat_seek_file,'avformat_seek_file');
   doCheckVar(avformat_flush,'avformat_flush');
   doCheckVar(av_read_play,'av_read_play');
   doCheckVar(av_read_pause,'av_read_pause');
   doCheckVar(avformat_close_input,'avformat_close_input');
   doCheckVar(avpriv_set_pts_info,'avpriv_set_pts_info');
   doCheckVar(avformat_write_header,'avformat_write_header');
   doCheckVar(avformat_init_output,'avformat_init_output');
   doCheckVar(av_write_frame,'av_write_frame');
   doCheckVar(av_interleaved_write_frame,'av_interleaved_write_frame');
   doCheckVar(av_write_uncoded_frame,'av_write_uncoded_frame');
   doCheckVar(av_interleaved_write_uncoded_frame,'av_interleaved_write_uncoded_frame');
   doCheckVar(av_write_uncoded_frame_query,'av_write_uncoded_frame_query');
   doCheckVar(av_write_trailer,'av_write_trailer');
   doCheckVar(av_guess_format,'av_guess_format');
   doCheckVar(av_guess_codec,'av_guess_codec');
   doCheckVar(av_get_output_timestamp,'av_get_output_timestamp');
   doCheckVar(av_hex_dump,'av_hex_dump');
   doCheckVar(av_hex_dump_log,'av_hex_dump_log');
   doCheckVar(av_pkt_dump2,'av_pkt_dump2');
   doCheckVar(av_pkt_dump_log2,'av_pkt_dump_log2');
   doCheckVar(av_codec_get_id,'av_codec_get_id');
   doCheckVar(av_codec_get_tag,'av_codec_get_tag');
   doCheckVar(av_codec_get_tag2,'av_codec_get_tag2');
   doCheckVar(av_find_default_stream_index,'av_find_default_stream_index');
   doCheckVar(av_index_search_timestamp,'av_index_search_timestamp');
   doCheckVar(avformat_index_get_entries_count,'avformat_index_get_entries_count');
   doCheckVar(avformat_index_get_entry,'avformat_index_get_entry');
   doCheckVar(avformat_index_get_entry_from_timestamp,'avformat_index_get_entry_from_timestamp');
   doCheckVar(av_add_index_entry,'av_add_index_entry');
   doCheckVar(av_url_split,'av_url_split');
   doCheckVar(av_dump_format,'av_dump_format');
   doCheckVar(av_get_frame_filename2,'av_get_frame_filename2');
   doCheckVar(av_get_frame_filename,'av_get_frame_filename');
   doCheckVar(av_filename_number_test,'av_filename_number_test');
   doCheckVar(av_sdp_create,'av_sdp_create');
   doCheckVar(av_match_ext,'av_match_ext');
   doCheckVar(avformat_query_codec,'avformat_query_codec');
   doCheckVar(av_guess_sample_aspect_ratio,'av_guess_sample_aspect_ratio');
   doCheckVar(av_guess_frame_rate,'av_guess_frame_rate');
   doCheckVar(avformat_match_stream_specifier,'avformat_match_stream_specifier');
   doCheckVar(avformat_queue_attached_pictures,'avformat_queue_attached_pictures');
   doCheckVar(avformat_transfer_internal_stream_timing_info,'avformat_transfer_internal_stream_timing_info');
   doCheckVar(av_stream_get_codec_timebase,'av_stream_get_codec_timebase');
   doCheckVar(avio_check,'avio_check');
   doCheckVar(avio_open_dir,'avio_open_dir');
   doCheckVar(avio_read_dir,'avio_read_dir');
   doCheckVar(avio_close_dir,'avio_close_dir');
   doCheckVar(avio_free_directory_entry,'avio_free_directory_entry');
   doCheckVar(avio_context_free,'avio_context_free');
   doCheckVar(avio_w8,'avio_w8');
   doCheckVar(avio_write,'avio_write');
   doCheckVar(avio_wl64,'avio_wl64');
   doCheckVar(avio_wb64,'avio_wb64');
   doCheckVar(avio_wl32,'avio_wl32');
   doCheckVar(avio_wb32,'avio_wb32');
   doCheckVar(avio_wl24,'avio_wl24');
   doCheckVar(avio_wb24,'avio_wb24');
   doCheckVar(avio_wl16,'avio_wl16');
   doCheckVar(avio_wb16,'avio_wb16');
   doCheckVar(avio_put_str,'avio_put_str');
   doCheckVar(avio_put_str16le,'avio_put_str16le');
   doCheckVar(avio_put_str16be,'avio_put_str16be');
   doCheckVar(avio_write_marker,'avio_write_marker');
   doCheckVar(avio_seek,'avio_seek');
   doCheckVar(avio_skip,'avio_skip');
   doCheckVar(avio_size,'avio_size');
   doCheckVar(avio_feof,'avio_feof');
   doCheckVar(avio_printf,'avio_printf');
   doCheckVar(avio_flush,'avio_flush');
   doCheckVar(avio_read,'avio_read');
   doCheckVar(avio_read_partial,'avio_read_partial');
   doCheckVar(avio_r8,'avio_r8');
   doCheckVar(avio_rl16,'avio_rl16');
   doCheckVar(avio_rl24,'avio_rl24');
   doCheckVar(avio_rl32,'avio_rl32');
   doCheckVar(avio_rl64,'avio_rl64');
   doCheckVar(avio_rb16,'avio_rb16');
   doCheckVar(avio_rb24,'avio_rb24');
   doCheckVar(avio_rb32,'avio_rb32');
   doCheckVar(avio_rb64,'avio_rb64');
   doCheckVar(avio_get_str,'avio_get_str');
   doCheckVar(avio_get_str16le,'avio_get_str16le');
   doCheckVar(avio_get_str16be,'avio_get_str16be');
   doCheckVar(avio_open,'avio_open');
   doCheckVar(avio_open2,'avio_open2');
   doCheckVar(avio_close,'avio_close');
   doCheckVar(avio_closep,'avio_closep');
   doCheckVar(avio_open_dyn_buf,'avio_open_dyn_buf');
   doCheckVar(avio_get_dyn_buf,'avio_get_dyn_buf');
   doCheckVar(avio_close_dyn_buf,'avio_close_dyn_buf');
   doCheckVar(avio_enum_protocols,'avio_enum_protocols');
   doCheckVar(avio_protocol_get_class,'avio_protocol_get_class');
   doCheckVar(avio_pause,'avio_pause');
   doCheckVar(avio_seek_time,'avio_seek_time');
   doCheckVar(avio_read_to_bprint,'avio_read_to_bprint');
   doCheckVar(avio_accept,'avio_accept');
   doCheckVar(avio_handshake,'avio_handshake');  
   doCheckVar(avio_alloc_context,'avio_alloc_context');

   FWorkingMemo.Lines.EndUpdate;

end;

procedure TForm1.TestLibpostproc;
begin
   FWorkingMemo:=Memo4;
   FWorkingMemo.Lines.add('........................................');
   FWorkingMemo.Lines.add('');
   FWorkingMemo.Lines.BeginUpdate;

   doCheckVar(postproc_version,'postproc_version');
   doCheckVar(postproc_configuration,'postproc_configuration');
   doCheckVar(postproc_license,'postproc_license ');
   doCheckVar(pp_postprocess,'pp_postprocess');
   doCheckVar(pp_get_mode_by_name_and_quality,'pp_get_mode_by_name_and_quality');
   doCheckVar(pp_free_mode,'pp_free_mode');
   doCheckVar(pp_get_context,'pp_get_context');
   doCheckVar(pp_free_context,'pp_free_context');

   FWorkingMemo.Lines.EndUpdate;

end;

procedure TForm1.TestLibswscale;
begin
   FWorkingMemo:=Memo5;
   FWorkingMemo.Lines.add('........................................');
   FWorkingMemo.Lines.add('');
   FWorkingMemo.Lines.BeginUpdate;

   doCheckVar(swscale_version,'swscale_version');
   doCheckVar(swscale_configuration,'swscale_configuration');
   doCheckVar(swscale_license,'swscale_license');
   doCheckVar(sws_get_class,'sws_get_class');
   doCheckVar(sws_getCoefficients,'sws_getCoefficients');
   doCheckVar(sws_isSupportedInput,'sws_isSupportedInput');
   doCheckVar(sws_isSupportedOutput,'sws_isSupportedOutput');
   doCheckVar(sws_isSupportedEndiannessConversion,'sws_isSupportedEndiannessConversion');
   doCheckVar(sws_init_context,'sws_init_context');
   doCheckVar(sws_freeContext,'sws_freeContext');
   doCheckVar(sws_getContext,'sws_getContext');
   doCheckVar(sws_scale,'sws_scale');
   doCheckVar(sws_scale_frame,'sws_scale_frame');
   doCheckVar(sws_frame_start,'sws_frame_start');
   doCheckVar(sws_frame_end,'sws_frame_end');
   doCheckVar(sws_send_slice,'sws_send_slice');
   doCheckVar(sws_receive_slice,'sws_receive_slice');
   doCheckVar(sws_receive_slice_alignment,'sws_receive_slice_alignment');
   doCheckVar(sws_setColorspaceDetails,'sws_setColorspaceDetails');
   doCheckVar(sws_getColorspaceDetails,'sws_getColorspaceDetails');
   doCheckVar(sws_allocVec,'sws_allocVec');
   doCheckVar(sws_getGaussianVec,'sws_getGaussianVec');
   doCheckVar(sws_scaleVec,'sws_scaleVec');
   doCheckVar(sws_normalizeVec,'sws_normalizeVec');
   doCheckVar(sws_freeVec,'sws_freeVec');
   doCheckVar(sws_getCachedContext,'sws_getCachedContext');
   doCheckVar(sws_convertPalette8ToPacked32,'sws_convertPalette8ToPacked32');
   doCheckVar(sws_convertPalette8ToPacked24,'sws_convertPalette8ToPacked24');
   doCheckVar(sws_getDefaultFilter,'sws_getDefaultFilter');
   doCheckVar(sws_freeFilter,'sws_freeFilter');

   FWorkingMemo.Lines.EndUpdate;

end;

procedure TForm1.TestLibswresample;
begin
   FWorkingMemo:=Memo6;
   FWorkingMemo.Lines.add('........................................');
   FWorkingMemo.Lines.add('');
   FWorkingMemo.Lines.BeginUpdate;

   doCheckVar(swresample_version,'swresample_version');
   doCheckVar(swresample_configuration,'swresample_configuration');
   doCheckVar(swresample_license,'swresample_license');
   doCheckVar(swr_init,'swr_init');
   doCheckVar(swr_is_initialized,'swr_is_initialized');   
   doCheckVar(swr_alloc_set_opts,'swr_alloc_set_opts');
   doCheckVar(swr_alloc_set_opts2,'swr_alloc_set_opts2');
   doCheckVar(swr_free,'swr_free');
   doCheckVar(swr_close,'swr_close');
   doCheckVar(swr_convert,'swr_convert');
   doCheckVar(swr_next_pts,'swr_next_pts');
   doCheckVar(swr_set_compensation,'swr_set_compensation');
   doCheckVar(swr_set_channel_mapping,'swr_set_channel_mapping');
   doCheckVar(swr_build_matrix,'swr_build_matrix');
   doCheckVar(swr_build_matrix2,'swr_build_matrix2');
   doCheckVar(swr_set_matrix,'swr_set_matrix');
   doCheckVar(swr_drop_output,'swr_drop_output');
   doCheckVar(swr_inject_silence,'swr_inject_silence');
   doCheckVar(swr_get_delay,'swr_get_delay');
   doCheckVar(swr_get_out_samples,'swr_get_out_samples');
   doCheckVar(swr_convert_frame,'swr_convert_frame');
   doCheckVar(swr_config_frame,'swr_config_frame');  
   doCheckVar(swr_alloc,'swr_alloc');

   FWorkingMemo.Lines.EndUpdate;

end;

procedure TForm1.TestLibavcodec;
begin
   FWorkingMemo:=Memo7;
   FWorkingMemo.Lines.add('........................................');
   FWorkingMemo.Lines.add('');
   FWorkingMemo.Lines.BeginUpdate;

   doCheckVar(avcodec_version,'avcodec_version');
   doCheckVar(avcodec_configuration,'avcodec_configuration');
   doCheckVar(avcodec_license,'avcodec_license');
   doCheckVar(avcodec_get_class,'avcodec_get_class');
   doCheckVar(avcodec_alloc_context3,'avcodec_alloc_context3');
   doCheckVar(avcodec_free_context,'avcodec_free_context');
   doCheckVar(avcodec_get_subtitle_rect_class,'avcodec_get_subtitle_rect_class');
   doCheckVar(avcodec_parameters_from_context,'avcodec_parameters_from_context');
   doCheckVar(avcodec_parameters_to_context,'avcodec_parameters_to_context');
   doCheckVar(avcodec_open2,'avcodec_open2');
   doCheckVar(avcodec_close,'avcodec_close');
   doCheckVar(avsubtitle_free,'avsubtitle_free');
   doCheckVar(avcodec_default_get_buffer2,'avcodec_default_get_buffer2');
   doCheckVar(avcodec_default_get_encode_buffer,'avcodec_default_get_encode_buffer');
   doCheckVar(avcodec_align_dimensions,'avcodec_align_dimensions');
   doCheckVar(avcodec_align_dimensions2,'avcodec_align_dimensions2');
   doCheckVar(avcodec_enum_to_chroma_pos,'avcodec_enum_to_chroma_pos');
   doCheckVar(avcodec_decode_subtitle2,'avcodec_decode_subtitle2');
   doCheckVar(avcodec_send_packet,'avcodec_send_packet');
   doCheckVar(avcodec_receive_frame,'avcodec_receive_frame');
   doCheckVar(avcodec_send_frame,'avcodec_send_frame');
   doCheckVar(avcodec_receive_packet,'avcodec_receive_packet');
   doCheckVar(avcodec_get_hw_frames_parameters,'avcodec_get_hw_frames_parameters');
   doCheckVar(av_parser_iterate,'av_parser_iterate');
   doCheckVar(av_parser_init,'av_parser_init');
   doCheckVar(av_parser_parse2,'av_parser_parse2');
   doCheckVar(av_parser_close,'av_parser_close');
   doCheckVar(avcodec_encode_subtitle,'avcodec_encode_subtitle');
   doCheckVar(avcodec_pix_fmt_to_codec_tag,'avcodec_pix_fmt_to_codec_tag');
   doCheckVar(avcodec_string,'avcodec_string');
   doCheckVar(avcodec_default_execute,'avcodec_default_execute');
   doCheckVar(avcodec_default_execute2,'avcodec_default_execute2');
   doCheckVar(avcodec_fill_audio_frame,'avcodec_fill_audio_frame');
   doCheckVar(avcodec_flush_buffers,'avcodec_flush_buffers');
   doCheckVar(av_get_audio_frame_duration,'av_get_audio_frame_duration');
   doCheckVar(av_fast_padded_malloc,'av_fast_padded_malloc');
   doCheckVar(av_fast_padded_mallocz,'av_fast_padded_mallocz');
   doCheckVar(avcodec_is_open,'avcodec_is_open');
   doCheckVar(av_ac3_parse_header,'av_ac3_parse_header');
   doCheckVar(av_adts_header_parse,'av_adts_header_parse');
   doCheckVar(avcodec_dct_alloc,'avcodec_dct_alloc');
   doCheckVar(avcodec_dct_init,'avcodec_dct_init');
   doCheckVar(avcodec_dct_get_class,'avcodec_dct_get_class');
   doCheckVar(av_fft_init,'av_fft_init');
   doCheckVar(av_fft_permute,'av_fft_permute');
   doCheckVar(av_fft_calc,'av_fft_calc');
   doCheckVar(av_fft_end,'av_fft_end');
   doCheckVar(av_rdft_init,'av_rdft_init');
   doCheckVar(av_rdft_calc,'av_rdft_calc');
   doCheckVar(av_rdft_end,'av_rdft_end');
   doCheckVar(av_dct_init,'av_dct_init');
   doCheckVar(av_dct_calc,'av_dct_calc');
   doCheckVar(av_dct_end,'av_dct_end');
   doCheckVar(av_bsf_get_by_name,'av_bsf_get_by_name');
   doCheckVar(av_bsf_iterate,'av_bsf_iterate');
   doCheckVar(av_bsf_alloc,'av_bsf_alloc');
   doCheckVar(av_bsf_init,'av_bsf_init');
   doCheckVar(av_bsf_send_packet,'av_bsf_send_packet');
   doCheckVar(av_bsf_receive_packet,'av_bsf_receive_packet');
   doCheckVar(av_bsf_flush,'av_bsf_flush');
   doCheckVar(av_bsf_free,'av_bsf_free');
   doCheckVar(av_bsf_get_class,'av_bsf_get_class');
   doCheckVar(av_bsf_list_free,'av_bsf_list_free');
   doCheckVar(av_bsf_list_append,'av_bsf_list_append');
   doCheckVar(av_bsf_list_append2,'av_bsf_list_append2');
   doCheckVar(av_bsf_list_finalize,'av_bsf_list_finalize');
   doCheckVar(av_bsf_list_parse_str,'av_bsf_list_parse_str');
   doCheckVar(avcodec_descriptor_get,'avcodec_descriptor_get');
   doCheckVar(avcodec_descriptor_next,'avcodec_descriptor_next');
   doCheckVar(avcodec_descriptor_get_by_name,'avcodec_descriptor_get_by_name');
   doCheckVar(avcodec_get_name,'avcodec_get_name');
   doCheckVar(av_get_bits_per_sample,'av_get_bits_per_sample');
   doCheckVar(av_get_exact_bits_per_sample,'av_get_exact_bits_per_sample');
   doCheckVar(avcodec_profile_name,'avcodec_profile_name');
   doCheckVar(avcodec_parameters_alloc,'avcodec_parameters_alloc');
   doCheckVar(avcodec_parameters_free,'avcodec_parameters_free');
   doCheckVar(avcodec_parameters_copy,'avcodec_parameters_copy');
   doCheckVar(av_get_audio_frame_duration2,'av_get_audio_frame_duration2');
   doCheckVar(av_cpb_properties_alloc,'av_cpb_properties_alloc');
   doCheckVar(av_xiphlacing,'av_xiphlacing');
   doCheckVar(av_dirac_parse_sequence_header,'av_dirac_parse_sequence_header');
   doCheckVar(av_dv_frame_profile,'av_dv_frame_profile');
   doCheckVar(av_dv_codec_profile,'av_dv_codec_profile');
   doCheckVar(av_dv_codec_profile2,'av_dv_codec_profile2');
   doCheckVar(av_jni_set_java_vm,'av_jni_set_java_vm');
   doCheckVar(av_jni_get_java_vm,'av_jni_get_java_vm');
   doCheckVar(av_mediacodec_alloc_context,'av_mediacodec_alloc_context');
   doCheckVar(av_mediacodec_default_init,'av_mediacodec_default_init');
   doCheckVar(av_mediacodec_default_free,'av_mediacodec_default_free');
   doCheckVar(av_mediacodec_release_buffer,'av_mediacodec_release_buffer');
   doCheckVar(av_mediacodec_render_buffer_at_time,'av_mediacodec_render_buffer_at_time');
   doCheckVar(av_packet_alloc,'av_packet_alloc');
   doCheckVar(av_packet_clone,'av_packet_clone');
   doCheckVar(av_packet_free,'av_packet_free');
   doCheckVar(av_new_packet,'av_new_packet');
   doCheckVar(av_shrink_packet,'av_shrink_packet');
   doCheckVar(av_grow_packet,'av_grow_packet');
   doCheckVar(av_packet_from_data,'av_packet_from_data');
   doCheckVar(av_packet_new_side_data,'av_packet_new_side_data');
   doCheckVar(av_packet_add_side_data,'av_packet_add_side_data');
   doCheckVar(av_packet_shrink_side_data,'av_packet_shrink_side_data');
   doCheckVar(av_packet_get_side_data,'av_packet_get_side_data');
   doCheckVar(av_packet_side_data_name,'av_packet_side_data_name');
   doCheckVar(av_packet_pack_dictionary,'av_packet_pack_dictionary');
   doCheckVar(av_packet_unpack_dictionary,'av_packet_unpack_dictionary');
   doCheckVar(av_packet_free_side_data,'av_packet_free_side_data');
   doCheckVar(av_packet_ref,'av_packet_ref');
   doCheckVar(av_packet_unref,'av_packet_unref');
   doCheckVar(av_packet_move_ref,'av_packet_move_ref');
   doCheckVar(av_packet_copy_props,'av_packet_copy_props');
   doCheckVar(av_packet_make_refcounted,'av_packet_make_refcounted');
   doCheckVar(av_packet_make_writable,'av_packet_make_writable');
   doCheckVar(av_packet_rescale_ts,'av_packet_rescale_ts');
   doCheckVar(av_qsv_alloc_context,'av_qsv_alloc_context');
   doCheckVar(av_vorbis_parse_init,'av_vorbis_parse_init');
   doCheckVar(av_vorbis_parse_free,'av_vorbis_parse_free');
   doCheckVar(av_vorbis_parse_frame_flags,'av_vorbis_parse_frame_flags');
   doCheckVar(av_vorbis_parse_frame,'av_vorbis_parse_frame');
   doCheckVar(av_vorbis_parse_reset,'av_vorbis_parse_reset');  
   doCheckVar(av_codec_iterate,'av_codec_iterate');
   doCheckVar(avcodec_find_decoder,'avcodec_find_decoder');
   doCheckVar(avcodec_find_decoder_by_name,'avcodec_find_decoder_by_name');
   doCheckVar(avcodec_find_encoder,'avcodec_find_encoder');
   doCheckVar(avcodec_find_encoder_by_name,'avcodec_find_encoder_by_name');
   doCheckVar(av_codec_is_encoder,'av_codec_is_encoder');
   doCheckVar(av_codec_is_decoder,'av_codec_is_decoder');
   doCheckVar(av_get_profile_name,'av_get_profile_name');
   doCheckVar(avcodec_get_hw_config,'avcodec_get_hw_config');

   FWorkingMemo.Lines.EndUpdate;

end;

procedure TForm1.TestLibavutil;
begin
   FWorkingMemo:=Memo8;
   FWorkingMemo.Lines.add('........................................');
   FWorkingMemo.Lines.add('');
   FWorkingMemo.Lines.BeginUpdate;

   doCheckVar(avutil_version,'avutil_version');
   doCheckVar(av_version_info,'av_version_info');
   doCheckVar(avutil_configuration,'avutil_configuration');
   doCheckVar(avutil_license,'avutil_license');
   doCheckVar(av_get_media_type_string,'av_get_media_type_string');
   doCheckVar(av_get_picture_type_char,'av_get_picture_type_char');
   doCheckVar(av_fourcc_make_string,'av_fourcc_make_string');
   doCheckVar(av_aes_init,'av_aes_init');
   doCheckVar(av_aes_crypt,'av_aes_crypt');
   doCheckVar(av_aes_ctr_init,'av_aes_ctr_init');
   doCheckVar(av_aes_ctr_free,'av_aes_ctr_free');
   doCheckVar(av_aes_ctr_crypt,'av_aes_ctr_crypt');
   doCheckVar(av_aes_ctr_get_iv,'av_aes_ctr_get_iv');
   doCheckVar(av_aes_ctr_set_random_iv,'av_aes_ctr_set_random_iv');
   doCheckVar(av_aes_ctr_set_iv,'av_aes_ctr_set_iv');
   doCheckVar(av_aes_ctr_set_full_iv,'av_aes_ctr_set_full_iv');
   doCheckVar(av_aes_ctr_increment_iv,'av_aes_ctr_increment_iv');
   doCheckVar(av_assert0_fpu,'av_assert0_fpu');
   doCheckVar(av_strstart,'av_strstart');
   doCheckVar(av_stristart,'av_stristart');
   doCheckVar(av_stristr,'av_stristr');
   doCheckVar(av_strnstr,'av_strnstr');
   doCheckVar(av_strlcpy,'av_strlcpy');
   doCheckVar(av_strlcat,'av_strlcat');
   doCheckVar(av_get_token,'av_get_token');
   doCheckVar(av_strtok,'av_strtok');
   doCheckVar(av_strncasecmp,'av_strncasecmp');
   doCheckVar(av_strireplace,'av_strireplace');
   doCheckVar(av_basename,'av_basename');
   doCheckVar(av_dirname,'av_dirname');
   doCheckVar(av_match_name,'av_match_name');
   doCheckVar(av_append_path_component,'av_append_path_component');
   doCheckVar(av_match_list,'av_match_list');
   doCheckVar(av_sscanf,'av_sscanf');
   doCheckVar(av_base64_decode,'av_base64_decode');
   doCheckVar(av_base64_encode,'av_base64_encode');
   doCheckVar(av_blowfish_alloc,'av_blowfish_alloc');
   doCheckVar(av_blowfish_init,'av_blowfish_init');
   doCheckVar(av_blowfish_crypt_ecb,'av_blowfish_crypt_ecb');
   doCheckVar(av_blowfish_crypt,'av_blowfish_crypt');
   doCheckVar(av_bprint_init,'av_bprint_init');
   doCheckVar(av_bprint_init_for_buffer,'av_bprint_init_for_buffer');
   doCheckVar(av_vbprintf,'av_vbprintf');
   doCheckVar(av_bprint_chars,'av_bprint_chars');
   doCheckVar(av_bprint_append_data,'av_bprint_append_data');
   doCheckVar(av_bprint_strftime,'av_bprint_strftime');
   doCheckVar(av_bprint_get_buffer,'av_bprint_get_buffer');
   doCheckVar(av_bprint_clear,'av_bprint_clear');
   doCheckVar(av_bprint_escape,'av_bprint_escape');
   doCheckVar(av_buffer_alloc,'av_buffer_alloc');
   doCheckVar(av_buffer_allocz,'av_buffer_allocz');
   doCheckVar(av_buffer_create,'av_buffer_create');
   doCheckVar(av_buffer_default_free,'av_buffer_default_free');
   doCheckVar(av_buffer_ref,'av_buffer_ref');
   doCheckVar(av_buffer_unref,'av_buffer_unref');
   doCheckVar(av_buffer_is_writable,'av_buffer_is_writable');
   doCheckVar(av_buffer_get_opaque,'av_buffer_get_opaque');
   doCheckVar(av_buffer_get_ref_count,'av_buffer_get_ref_count');
   doCheckVar(av_buffer_make_writable,'av_buffer_make_writable');
   doCheckVar(av_buffer_realloc,'av_buffer_realloc');
   doCheckVar(av_buffer_replace,'av_buffer_replace');
   doCheckVar(av_buffer_pool_init,'av_buffer_pool_init');
   doCheckVar(av_buffer_pool_init2,'av_buffer_pool_init2');
   doCheckVar(av_buffer_pool_uninit,'av_buffer_pool_uninit');
   doCheckVar(av_buffer_pool_get,'av_buffer_pool_get');
   doCheckVar(av_buffer_pool_buffer_get_opaque,'av_buffer_pool_buffer_get_opaque');
   doCheckVar(av_camellia_init,'av_camellia_init');
   doCheckVar(av_camellia_crypt,'av_camellia_crypt');
   doCheckVar(av_cast5_init,'av_cast5_init');
   doCheckVar(av_cast5_crypt,'av_cast5_crypt');
   doCheckVar(av_cast5_crypt2,'av_cast5_crypt2');
   doCheckVar(av_channel_name,'av_channel_name');
   doCheckVar(av_channel_name_bprint,'av_channel_name_bprint');
   doCheckVar(av_channel_description,'av_channel_description');
   doCheckVar(av_channel_description_bprint,'av_channel_description_bprint');
   doCheckVar(av_channel_layout_from_mask,'av_channel_layout_from_mask');
   doCheckVar(av_channel_layout_from_string,'av_channel_layout_from_string');
   doCheckVar(av_channel_layout_default,'av_channel_layout_default');
   doCheckVar(av_channel_layout_standard,'av_channel_layout_standard');
   doCheckVar(av_channel_layout_uninit,'av_channel_layout_uninit');
   doCheckVar(av_channel_layout_copy,'av_channel_layout_copy');
   doCheckVar(av_channel_layout_describe,'av_channel_layout_describe');
   doCheckVar(av_channel_layout_describe_bprint,'av_channel_layout_describe_bprint');
   doCheckVar(av_channel_layout_index_from_channel,'av_channel_layout_index_from_channel');
   doCheckVar(av_channel_layout_index_from_string,'av_channel_layout_index_from_string');
   doCheckVar(av_channel_layout_subset,'av_channel_layout_subset');
   doCheckVar(av_channel_layout_check,'av_channel_layout_check');
   doCheckVar(av_channel_layout_compare,'av_channel_layout_compare');
   doCheckVar(av_get_cpu_flags,'av_get_cpu_flags');
   doCheckVar(av_force_cpu_flags,'av_force_cpu_flags');
   doCheckVar(av_parse_cpu_caps,'av_parse_cpu_caps');
   doCheckVar(av_cpu_count,'av_cpu_count');
   doCheckVar(av_cpu_force_count,'av_cpu_force_count');
   doCheckVar(av_cpu_max_align,'av_cpu_max_align');
   doCheckVar(av_crc_init,'av_crc_init');
   doCheckVar(av_crc_get_table,'av_crc_get_table');
   doCheckVar(av_csp_luma_coeffs_from_avcsp,'av_csp_luma_coeffs_from_avcsp');
   doCheckVar(av_csp_primaries_desc_from_id,'av_csp_primaries_desc_from_id');
   doCheckVar(av_detection_bbox_create_side_data,'av_detection_bbox_create_side_data');
   doCheckVar(av_dict_get,'av_dict_get');
   doCheckVar(av_dict_count,'av_dict_count');
   doCheckVar(av_dict_set,'av_dict_set');
   doCheckVar(av_dict_set_int,'av_dict_set_int');
   doCheckVar(av_dict_parse_string,'av_dict_parse_string');
   doCheckVar(av_dict_copy,'av_dict_copy');
   doCheckVar(av_dict_free,'av_dict_free');
   doCheckVar(av_dict_get_string,'av_dict_get_string');
   doCheckVar(av_display_rotation_get,'av_display_rotation_get');
   doCheckVar(av_display_rotation_set,'av_display_rotation_set');
   doCheckVar(av_display_matrix_flip,'av_display_matrix_flip');
   doCheckVar(av_dovi_alloc,'av_dovi_alloc');
   doCheckVar(av_downmix_info_update_side_data,'av_downmix_info_update_side_data');
   doCheckVar(av_encryption_info_alloc,'av_encryption_info_alloc');
   doCheckVar(av_encryption_info_clone,'av_encryption_info_clone');
   doCheckVar(av_encryption_info_free,'av_encryption_info_free');
   doCheckVar(av_encryption_info_get_side_data,'av_encryption_info_get_side_data');
   doCheckVar(av_encryption_info_add_side_data,'av_encryption_info_add_side_data');
   doCheckVar(av_encryption_init_info_alloc,'av_encryption_init_info_alloc');
   doCheckVar(av_encryption_init_info_free,'av_encryption_init_info_free');
   doCheckVar(av_encryption_init_info_get_side_data,'av_encryption_init_info_get_side_data');
   doCheckVar(av_encryption_init_info_add_side_data,'av_encryption_init_info_add_side_data');
   doCheckVar(av_strerror,'av_strerror');
   doCheckVar(av_expr_parse_and_eval,'av_expr_parse_and_eval');
   doCheckVar(av_expr_parse,'av_expr_parse');
   doCheckVar(av_expr_eval,'av_expr_eval');
   doCheckVar(av_expr_count_vars,'av_expr_count_vars');
   doCheckVar(av_expr_count_func,'av_expr_count_func');
   doCheckVar(av_expr_free,'av_expr_free');
   doCheckVar(av_strtod,'av_strtod');
   doCheckVar(av_file_unmap,'av_file_unmap');
   doCheckVar(av_tempfile,'av_tempfile');
   doCheckVar(av_film_grain_params_alloc,'av_film_grain_params_alloc');
   doCheckVar(av_film_grain_params_create_side_data,'av_film_grain_params_create_side_data');
   doCheckVar(av_get_colorspace_name,'av_get_colorspace_name');
   doCheckVar(av_frame_alloc,'av_frame_alloc');
   doCheckVar(av_frame_free,'av_frame_free');
   doCheckVar(av_frame_ref,'av_frame_ref');
   doCheckVar(av_frame_clone,'av_frame_clone');
   doCheckVar(av_frame_unref,'av_frame_unref');
   doCheckVar(av_frame_move_ref,'av_frame_move_ref');
   doCheckVar(av_frame_get_buffer,'av_frame_get_buffer');
   doCheckVar(av_frame_is_writable,'av_frame_is_writable');
   doCheckVar(av_frame_make_writable,'av_frame_make_writable');
   doCheckVar(av_frame_copy,'av_frame_copy');
   doCheckVar(av_frame_copy_props,'av_frame_copy_props');
   doCheckVar(av_frame_get_plane_buffer,'av_frame_get_plane_buffer');
   doCheckVar(av_frame_new_side_data,'av_frame_new_side_data');
   doCheckVar(av_frame_new_side_data_from_buf,'av_frame_new_side_data_from_buf');
   doCheckVar(av_frame_get_side_data,'av_frame_get_side_data');
   doCheckVar(av_frame_remove_side_data,'av_frame_remove_side_data');
   doCheckVar(av_frame_apply_cropping,'av_frame_apply_cropping');
   doCheckVar(av_frame_side_data_name,'av_frame_side_data_name');
   doCheckVar(av_hash_alloc,'av_hash_alloc');
   doCheckVar(av_hash_names,'av_hash_names');
   doCheckVar(av_hash_get_name,'av_hash_get_name');
   doCheckVar(av_hash_get_size,'av_hash_get_size');
   doCheckVar(av_hash_init,'av_hash_init');
   doCheckVar(av_hash_update,'av_hash_update');
   doCheckVar(av_hash_final,'av_hash_final');
   doCheckVar(av_hash_final_bin,'av_hash_final_bin');
   doCheckVar(av_hash_final_hex,'av_hash_final_hex');
   doCheckVar(av_hash_final_b64,'av_hash_final_b64');
   doCheckVar(av_hash_freep,'av_hash_freep');
   doCheckVar(av_dynamic_hdr_plus_alloc,'av_dynamic_hdr_plus_alloc');
   doCheckVar(av_dynamic_hdr_plus_create_side_data,'av_dynamic_hdr_plus_create_side_data');
   doCheckVar(av_dynamic_hdr_vivid_alloc,'av_dynamic_hdr_vivid_alloc');
   doCheckVar(av_dynamic_hdr_vivid_create_side_data,'av_dynamic_hdr_vivid_create_side_data');
   doCheckVar(av_hmac_alloc,'av_hmac_alloc');
   doCheckVar(av_hmac_free,'av_hmac_free');
   doCheckVar(av_hmac_init,'av_hmac_init');
   doCheckVar(av_hmac_update,'av_hmac_update');
   doCheckVar(av_hmac_final,'av_hmac_final');
   doCheckVar(av_hmac_calc,'av_hmac_calc');
   doCheckVar(av_get_sample_fmt_name,'av_get_sample_fmt_name');
   doCheckVar(av_get_sample_fmt,'av_get_sample_fmt');
   doCheckVar(av_get_alt_sample_fmt,'av_get_alt_sample_fmt');
   doCheckVar(av_get_packed_sample_fmt,'av_get_packed_sample_fmt');
   doCheckVar(av_get_planar_sample_fmt,'av_get_planar_sample_fmt');
   doCheckVar(av_get_sample_fmt_string,'av_get_sample_fmt_string');
   doCheckVar(av_get_bytes_per_sample,'av_get_bytes_per_sample');
   doCheckVar(av_sample_fmt_is_planar,'av_sample_fmt_is_planar');
   doCheckVar(av_samples_get_buffer_size,'av_samples_get_buffer_size');
   doCheckVar(av_samples_fill_arrays,'av_samples_fill_arrays');
   doCheckVar(av_samples_alloc,'av_samples_alloc');
   doCheckVar(av_samples_alloc_array_and_samples,'av_samples_alloc_array_and_samples');
   doCheckVar(av_samples_copy,'av_samples_copy');
   doCheckVar(av_samples_set_silence,'av_samples_set_silence');
   doCheckVar(av_log,'av_log');
   doCheckVar(av_log_once,'av_log_once');
   doCheckVar(av_vlog,'av_vlog');
   doCheckVar(av_log_get_level,'av_log_get_level');
   doCheckVar(av_log_set_level,'av_log_set_level');
   doCheckVar(av_log_set_callback,'av_log_set_callback');
   doCheckVar(av_log_default_callback,'av_log_default_callback');
   doCheckVar(av_default_item_name,'av_default_item_name');
   doCheckVar(av_default_get_category,'av_default_get_category');
   doCheckVar(av_log_format_line,'av_log_format_line');
   doCheckVar(av_log_format_line2,'av_log_format_line2');
   doCheckVar(av_log_set_flags,'av_log_set_flags');
   doCheckVar(av_log_get_flags,'av_log_get_flags');
   doCheckVar(av_image_fill_max_pixsteps,'av_image_fill_max_pixsteps');
   doCheckVar(av_image_get_linesize,'av_image_get_linesize');
   doCheckVar(av_image_fill_linesizes,'av_image_fill_linesizes');
   doCheckVar(av_image_fill_plane_sizes,'av_image_fill_plane_sizes');
   doCheckVar(av_image_fill_pointers,'av_image_fill_pointers');
   doCheckVar(av_image_alloc,'av_image_alloc');
   doCheckVar(av_image_copy_plane,'av_image_copy_plane');
   doCheckVar(av_image_copy_plane_uc_from,'av_image_copy_plane_uc_from');
   doCheckVar(av_image_copy,'av_image_copy');
   doCheckVar(av_image_copy_uc_from,'av_image_copy_uc_from');
   doCheckVar(av_image_fill_arrays,'av_image_fill_arrays');
   doCheckVar(av_image_get_buffer_size,'av_image_get_buffer_size');
   doCheckVar(av_image_copy_to_buffer,'av_image_copy_to_buffer');
   doCheckVar(av_image_check_size,'av_image_check_size');
   doCheckVar(av_image_check_size2,'av_image_check_size2');
   doCheckVar(av_image_check_sar,'av_image_check_sar');
   doCheckVar(av_image_fill_black,'av_image_fill_black');
   doCheckVar(av_get_bits_per_pixel,'av_get_bits_per_pixel');
   doCheckVar(av_get_padded_bits_per_pixel,'av_get_padded_bits_per_pixel');
   doCheckVar(av_pix_fmt_desc_get,'av_pix_fmt_desc_get');
   doCheckVar(av_pix_fmt_desc_next,'av_pix_fmt_desc_next');
   doCheckVar(av_pix_fmt_desc_get_id,'av_pix_fmt_desc_get_id');
   doCheckVar(av_pix_fmt_get_chroma_sub_sample,'av_pix_fmt_get_chroma_sub_sample');
   doCheckVar(av_pix_fmt_count_planes,'av_pix_fmt_count_planes');
   doCheckVar(av_color_range_name,'av_color_range_name');
   doCheckVar(av_color_range_from_name,'av_color_range_from_name');
   doCheckVar(av_color_primaries_name,'av_color_primaries_name');
   doCheckVar(av_color_primaries_from_name,'av_color_primaries_from_name');
   doCheckVar(av_color_transfer_name,'av_color_transfer_name');
   doCheckVar(av_color_transfer_from_name,'av_color_transfer_from_name');
   doCheckVar(av_color_space_name,'av_color_space_name');
   doCheckVar(av_color_space_from_name,'av_color_space_from_name');
   doCheckVar(av_chroma_location_name,'av_chroma_location_name');
   doCheckVar(av_chroma_location_from_name,'av_chroma_location_from_name');
   doCheckVar(av_get_pix_fmt,'av_get_pix_fmt');
   doCheckVar(av_get_pix_fmt_name,'av_get_pix_fmt_name');
   doCheckVar(av_get_pix_fmt_string,'av_get_pix_fmt_string');
   doCheckVar(av_pix_fmt_swap_endianness,'av_pix_fmt_swap_endianness');
   doCheckVar(av_get_pix_fmt_loss,'av_get_pix_fmt_loss');
   doCheckVar(av_find_best_pix_fmt_of_2,'av_find_best_pix_fmt_of_2');
   doCheckVar(av_opt_show2,'av_opt_show2');
   doCheckVar(av_opt_set_defaults,'av_opt_set_defaults');
   doCheckVar(av_opt_set_defaults2,'av_opt_set_defaults2');
   doCheckVar(av_set_options_string,'av_set_options_string');
   doCheckVar(av_opt_set_from_string,'av_opt_set_from_string');
   doCheckVar(av_opt_free,'av_opt_free');
   doCheckVar(av_opt_flag_is_set,'av_opt_flag_is_set');
   doCheckVar(av_opt_set_dict,'av_opt_set_dict');
   doCheckVar(av_opt_set_dict2,'av_opt_set_dict2');
   doCheckVar(av_opt_get_key_value,'av_opt_get_key_value');
   doCheckVar(av_opt_eval_flags,'av_opt_eval_flags');
   doCheckVar(av_opt_eval_int,'av_opt_eval_int');
   doCheckVar(av_opt_eval_int64,'av_opt_eval_int64');
   doCheckVar(av_opt_eval_float,'av_opt_eval_float');
   doCheckVar(av_opt_eval_double,'av_opt_eval_double');
   doCheckVar(av_opt_eval_q,'av_opt_eval_q');
   doCheckVar(av_opt_find,'av_opt_find');
   doCheckVar(av_opt_find2,'av_opt_find2');
   doCheckVar(av_opt_next,'av_opt_next');
   doCheckVar(av_opt_child_next,'av_opt_child_next');
   doCheckVar(av_opt_child_class_iterate,'av_opt_child_class_iterate');
   doCheckVar(av_opt_set,'av_opt_set');
   doCheckVar(av_opt_set_int,'av_opt_set_int');
   doCheckVar(av_opt_set_double,'av_opt_set_double');
   doCheckVar(av_opt_set_q,'av_opt_set_q');
   doCheckVar(av_opt_set_bin,'av_opt_set_bin');
   doCheckVar(av_opt_set_image_size,'av_opt_set_image_size');
   doCheckVar(av_opt_set_pixel_fmt,'av_opt_set_pixel_fmt');
   doCheckVar(av_opt_set_sample_fmt,'av_opt_set_sample_fmt');
   doCheckVar(av_opt_set_video_rate,'av_opt_set_video_rate');
   doCheckVar(av_opt_set_channel_layout,'av_opt_set_channel_layout');
   doCheckVar(av_opt_set_dict_val,'av_opt_set_dict_val');
   doCheckVar(av_opt_get,'av_opt_get');
   doCheckVar(av_opt_get_int,'av_opt_get_int');
   doCheckVar(av_opt_get_double,'av_opt_get_double');
   doCheckVar(av_opt_get_q,'av_opt_get_q');
   doCheckVar(av_opt_get_image_size,'av_opt_get_image_size');
   doCheckVar(av_opt_get_pixel_fmt,'av_opt_get_pixel_fmt');
   doCheckVar(av_opt_get_sample_fmt,'av_opt_get_sample_fmt');
   doCheckVar(av_opt_get_video_rate,'av_opt_get_video_rate');
   doCheckVar(av_opt_get_channel_layout,'av_opt_get_channel_layout');
   doCheckVar(av_opt_get_dict_val,'av_opt_get_dict_val');
   doCheckVar(av_opt_ptr,'av_opt_ptr');
   doCheckVar(av_opt_freep_ranges,'av_opt_freep_ranges');
   doCheckVar(av_opt_query_ranges,'av_opt_query_ranges');
   doCheckVar(av_opt_copy,'av_opt_copy');
   doCheckVar(av_opt_query_ranges_default,'av_opt_query_ranges_default');
   doCheckVar(av_opt_is_set_to_default,'av_opt_is_set_to_default');
   doCheckVar(av_opt_is_set_to_default_by_name,'av_opt_is_set_to_default_by_name');
   doCheckVar(av_opt_serialize,'av_opt_serialize');
   doCheckVar(av_get_channel_layout,'av_get_channel_layout');
   doCheckVar(av_get_extended_channel_layout,'av_get_extended_channel_layout');
   doCheckVar(av_get_channel_layout_string,'av_get_channel_layout_string');
   doCheckVar(av_bprint_channel_layout,'av_bprint_channel_layout');
   doCheckVar(av_get_channel_layout_nb_channels,'av_get_channel_layout_nb_channels');
   doCheckVar(av_get_default_channel_layout,'av_get_default_channel_layout');
   doCheckVar(av_get_channel_layout_channel_index,'av_get_channel_layout_channel_index');
   doCheckVar(av_channel_layout_extract_channel,'av_channel_layout_extract_channel');
   doCheckVar(av_get_channel_name,'av_get_channel_name');
   doCheckVar(av_get_channel_description,'av_get_channel_description');
   doCheckVar(av_get_standard_channel_layout,'av_get_standard_channel_layout');
   doCheckVar(av_md5_alloc,'av_md5_alloc');
   doCheckVar(av_md5_init,'av_md5_init');
   doCheckVar(av_md5_update,'av_md5_update');
   doCheckVar(av_md5_final,'av_md5_final');
   doCheckVar(av_md5_sum,'av_md5_sum');
   doCheckVar(av_malloc,'av_malloc');
   doCheckVar(av_mallocz,'av_mallocz');
   doCheckVar(av_malloc_array,'av_malloc_array');
   doCheckVar(av_calloc,'av_calloc');
   doCheckVar(av_mallocz_array,'av_mallocz_array');
   doCheckVar(av_realloc,'av_realloc');
   doCheckVar(av_reallocp,'av_reallocp');
   doCheckVar(av_realloc_f,'av_realloc_f');
   doCheckVar(av_realloc_array,'av_realloc_array');
   doCheckVar(av_reallocp_array,'av_reallocp_array');
   doCheckVar(av_fast_realloc,'av_fast_realloc');
   doCheckVar(av_fast_malloc,'av_fast_malloc');
   doCheckVar(av_fast_mallocz,'av_fast_mallocz');
   doCheckVar(av_free,'av_free');
   doCheckVar(av_freep,'av_freep');
   doCheckVar(av_strdup,'av_strdup');
   doCheckVar(av_strndup,'av_strndup');
   doCheckVar(av_memdup,'av_memdup');
   doCheckVar(av_memcpy_backptr,'av_memcpy_backptr');
   doCheckVar(av_dynarray_add,'av_dynarray_add');
   doCheckVar(av_dynarray_add_nofree,'av_dynarray_add_nofree');
   doCheckVar(av_dynarray2_add,'av_dynarray2_add');
   doCheckVar(av_size_mult,'av_size_mult');
   doCheckVar(av_max_alloc,'av_max_alloc');  
   doCheckVar(av_gcd,'av_gcd');
   doCheckVar(av_rescale,'av_rescale');
   doCheckVar(av_rescale_rnd,'av_rescale_rnd');
   doCheckVar(av_rescale_q,'av_rescale_q');
   doCheckVar(av_rescale_q_rnd,'av_rescale_q_rnd');
   doCheckVar(av_compare_ts,'av_compare_ts');
   doCheckVar(av_compare_mod,'av_compare_mod');
   doCheckVar(av_rescale_delta,'av_rescale_delta');
   doCheckVar(av_add_stable,'av_add_stable');      
   doCheckVar(av_hwdevice_find_type_by_name,'av_hwdevice_find_type_by_name');
   doCheckVar(av_hwdevice_get_type_name,'av_hwdevice_get_type_name');
   doCheckVar(av_hwdevice_iterate_types,'av_hwdevice_iterate_types');
   doCheckVar(av_hwdevice_ctx_alloc,'av_hwdevice_ctx_alloc');
   doCheckVar(av_hwdevice_ctx_init,'av_hwdevice_ctx_init');
   doCheckVar(av_hwdevice_ctx_create,'av_hwdevice_ctx_create');
   doCheckVar(av_hwdevice_ctx_create_derived,'av_hwdevice_ctx_create_derived');
   doCheckVar(av_hwdevice_ctx_create_derived_opts,'av_hwdevice_ctx_create_derived_opts');
   doCheckVar(av_hwframe_ctx_alloc,'av_hwframe_ctx_alloc');
   doCheckVar(av_hwframe_ctx_init,'av_hwframe_ctx_init');
   doCheckVar(av_hwframe_get_buffer,'av_hwframe_get_buffer');
   doCheckVar(av_hwframe_transfer_data,'av_hwframe_transfer_data');
   doCheckVar(av_hwframe_transfer_get_formats,'av_hwframe_transfer_get_formats');
   doCheckVar(av_hwdevice_hwconfig_alloc,'av_hwdevice_hwconfig_alloc');
   doCheckVar(av_hwdevice_get_hwframe_constraints,'av_hwdevice_get_hwframe_constraints');
   doCheckVar(av_hwframe_constraints_free,'av_hwframe_constraints_free');
   doCheckVar(av_hwframe_map,'av_hwframe_map');
   doCheckVar(av_hwframe_ctx_create_derived,'av_hwframe_ctx_create_derived');   
   doCheckVar(av_parse_ratio,'av_parse_ratio');
   doCheckVar(av_parse_video_size,'av_parse_video_size');
   doCheckVar(av_parse_video_rate,'av_parse_video_rate');
   doCheckVar(av_parse_color,'av_parse_color');
   doCheckVar(av_get_known_color_name,'av_get_known_color_name');
   doCheckVar(av_parse_time,'av_parse_time');
   doCheckVar(av_find_info_tag,'av_find_info_tag');
   doCheckVar(av_small_strptime,'av_small_strptime');
   doCheckVar(av_timegm,'av_timegm'); 
   doCheckVar(av_audio_fifo_free,'av_audio_fifo_free');
   doCheckVar(av_audio_fifo_alloc,'av_audio_fifo_alloc');
   doCheckVar(av_audio_fifo_realloc,'av_audio_fifo_realloc');
   doCheckVar(av_audio_fifo_write,'av_audio_fifo_write');
   doCheckVar(av_audio_fifo_peek,'av_audio_fifo_peek');
   doCheckVar(av_audio_fifo_peek_at,'av_audio_fifo_peek_at');
   doCheckVar(av_audio_fifo_read,'av_audio_fifo_read');
   doCheckVar(av_audio_fifo_drain,'av_audio_fifo_drain');
   doCheckVar(av_audio_fifo_reset,'av_audio_fifo_reset');
   doCheckVar(av_audio_fifo_size,'av_audio_fifo_size');
   doCheckVar(av_audio_fifo_space,'av_audio_fifo_space');
   doCheckVar(av_int_list_length_for_size,'av_int_list_length_for_size'); 
   doCheckVar(av_file_map,'av_file_map');


   FWorkingMemo.Lines.EndUpdate;

end;

end.

